##################################################
# header_common.py
# This file contains common declarations.
# DO NOT EDIT THIS FILE!
###################################################

#client events
multiplayer_event_set_item_selection                          = 0
multiplayer_event_set_bot_selection                           = 1
multiplayer_event_change_team_no                              = 2
multiplayer_event_change_troop_id                             = 3
multiplayer_event_admin_set_server_name                       = 4
multiplayer_event_admin_set_game_password                     = 5
multiplayer_event_admin_set_welcome_message                   = 6
multiplayer_event_start_map                          				  = 7
multiplayer_event_reset_map                          				  = 8
multiplayer_event_set_admin_settings                          = 9
multiplayer_event_start_new_poll                              = 10
multiplayer_event_answer_to_poll                              = 11
#multiplayer_event_admin_kick_player                           = 12
#multiplayer_event_admin_ban_player                            = 13
multiplayer_event_offer_duel                                  = 12
#MOD begin
multiplayer_event_admin_manage_player                         = 13
multiplayer_event_admin_cheats                        				= 14
multiplayer_event_agent_walk																	= 15
multiplayer_event_agent_sprint_limiter												= 16
multiplayer_event_agent_sprint_stop														= 17
multiplayer_event_switch_weapon_mode													= 18
multiplayer_event_shield_bash																	= 19
multiplayer_event_use_ammo_box                	              = 21
multiplayer_event_agent_spawn_item             	 	            = 22
multiplayer_event_agent_spawn_scene_prop       		            = 23
multiplayer_event_server_control_scene_prop                   = 24
multiplayer_event_server_set_player_slot                      = 25
multiplayer_event_server_set_agent_slot                       = 26
multiplayer_event_server_set_advanced_ai_order                = 27

multiplayer_event_clan_chat                                	  = 28
multiplayer_event_admin_chat                                  = 29
multiplayer_event_admin_message                               = 30

multiplayer_event_reset_account_password                      = 31
multiplayer_event_version_check																= 32
#MOD end


#server events
multiplayer_event_return_admin_settings											  = 53

multiplayer_event_return_server_name                          = 54
multiplayer_event_return_game_password                        = 55

multiplayer_event_return_confirmation                         = 56
multiplayer_event_return_rejection                            = 57
multiplayer_event_return_server_mission_timer_while_player_joined = 59

multiplayer_event_show_multiplayer_message                    = 60
multiplayer_event_draw_this_round                             = 61
# multiplayer_event_set_attached_scene_prop                     = 62
# multiplayer_event_set_team_flag_situation                     = 63
multiplayer_event_set_team_score                              = 64
multiplayer_event_set_num_agents_around_flag                  = 65
multiplayer_event_ask_for_poll                                = 66
# multiplayer_event_change_flag_owner                           = 67
multiplayer_event_use_item                                    = 68
multiplayer_event_set_scene_prop_open_or_close                = 69
multiplayer_event_set_round_start_time                        = 70
multiplayer_event_force_start_team_selection                  = 71
multiplayer_event_return_player_respawn_spent                 = 72
multiplayer_event_start_death_mode                            = 73
#multiplayer_event_set_player_score_kill_death                 = 78
#multiplayer_event_set_day_time                                = 89

multiplayer_event_show_duel_request                           = 90
multiplayer_event_start_duel                                  = 91
multiplayer_event_cancel_duel                                 = 92
#multiplayer_event_show_server_message                         = 115

#MOD begin
multiplayer_event_client_set_player_score_count               = 96
multiplayer_event_client_set_player_kill_count               	= 97
multiplayer_event_client_set_player_death_count               = 98
multiplayer_event_client_set_prop_slot                        = 99
multiplayer_event_client_set_troop_slot                       = 100
multiplayer_event_client_set_player_slot                      = 101
multiplayer_event_client_set_agent_slot                       = 102

multiplayer_event_client_set_banner                     			= 103

multiplayer_event_client_set_attribute                        = 104
multiplayer_event_client_set_proficiency                      = 105
multiplayer_event_client_set_skill                            = 106
multiplayer_event_client_raise_all_proficiencies              = 107
multiplayer_event_client_set_experience                       = 108
multiplayer_event_client_item_availability                    = 109
multiplayer_event_client_control_scene_prop                   = 110
multiplayer_event_client_prop_missile_init                    = 111
multiplayer_event_return_explosion_at_pos                     = 112
multiplayer_event_start_use_item                              = 113
multiplayer_event_return_thunderbolt                 				  = 114

multiplayer_event_return_weather_time                   		  = 115
multiplayer_event_return_message_color                        = 116
multiplayer_event_show_message                                = 117
multiplayer_event_store_string                                = 118

multiplayer_event_client_set_admin                            = 119
multiplayer_event_client_agent_set_horse_speed                = 120
multiplayer_event_client_agent_set_bleed_interval             = 121
#MOD end
#max event number 127



#multiplayer message types
multiplayer_message_type_auto_team_balance_done      = 2
multiplayer_message_type_auto_team_balance_next      = 3
multiplayer_message_type_capture_the_flag_score      = 4
multiplayer_message_type_flag_returned_home          = 5
multiplayer_message_type_capture_the_flag_stole      = 6
multiplayer_message_type_poll_result                 = 7
multiplayer_message_type_flag_neutralized            = 8
multiplayer_message_type_flag_captured               = 9
multiplayer_message_type_flag_is_pulling             = 10
multiplayer_message_type_auto_team_balance_no_need   = 11
multiplayer_message_type_round_result_in_battle_mode = 12
multiplayer_message_type_round_result_in_siege_mode  = 13
multiplayer_message_type_round_draw                  = 14
multiplayer_message_type_target_destroyed            = 15
multiplayer_message_type_defenders_saved_n_targets   = 16
multiplayer_message_type_attackers_won_the_round     = 17
multiplayer_message_type_start_death_mode            = 18

#multiplayer game type indices
multiplayer_game_type_deathmatch             = 0
multiplayer_game_type_team_deathmatch        = 1
multiplayer_game_type_battle                 = 2
multiplayer_game_type_siege                  = 3
multiplayer_game_type_duel                   = 4
multiplayer_num_game_types                   = 5

#admin panel value ranges
multiplayer_round_max_seconds_min            = 60
multiplayer_round_max_seconds_max            = 3601
multiplayer_respawn_period_min               = 3
multiplayer_respawn_period_max               = 31 #can only be 30 seconds max (due to agent deletion after that period)

# multiplayer_siege_mod_defender_team_extra_respawn_time = 27 #It was 20 in 1.113 but it is increased it to 25 in 1.121 because defenders were mostly defeating enemy.
multiplayer_new_agents_finish_spawning_time = 30
multiplayer_max_possible_player_id = 251 #MOD edit was 1000

#team 1 and team 2 are 0 and 1 respectively
multi_team_spectator = 2
multi_team_unassigned = multi_team_spectator + 1

multi_data_maps_for_game_type_begin = 0
multi_data_maps_for_game_type_end = multi_data_maps_for_game_type_begin + 30
multi_data_troop_button_indices_begin = multi_data_maps_for_game_type_end
multi_data_troop_button_indices_end = multi_data_troop_button_indices_begin + 16 #maximum 16 troops per faction
multi_data_item_button_indices_begin = multi_data_troop_button_indices_end
multi_data_item_button_indices_end = multi_data_item_button_indices_begin + 100 #maximum 100 items per troop
multi_data_flag_owner_begin = multi_data_item_button_indices_end
multi_data_flag_owner_end = multi_data_flag_owner_begin + 10 #maximum of 10 flags per scene
multi_data_flag_players_around_begin = multi_data_flag_owner_end 
multi_data_flag_players_around_end = multi_data_flag_players_around_begin + 10 #maximum of 10 flags per scene
multi_data_flag_owned_seconds_begin = multi_data_flag_players_around_end
multi_data_flag_owned_seconds_end = multi_data_flag_owned_seconds_begin + 10 #maximum of 10 flags per scene
multi_data_flag_pull_code_begin = multi_data_flag_owned_seconds_end
multi_data_flag_pull_code_end = multi_data_flag_pull_code_begin + 10 #maximum of 10 flags per scene
multi_data_player_index_list_begin = multi_data_flag_pull_code_end

#Entry points 100..109 is used for showing initial points for moveable and usable scene props like siege ladder.
multi_entry_points_for_usable_items_start = 100
multi_entry_points_for_usable_items_end = multi_entry_points_for_usable_items_start + 10


#Troops
multi_troop_class_other = 0
multi_troop_class_peasant = 1
multi_troop_class_spearman = 2
multi_troop_class_infantry = 3

multi_troop_class_archer = 4
multi_troop_class_crossbowman = 5
multi_troop_class_musketeer = 6

multi_troop_class_cavalry = 7
multi_troop_class_mounted_archer = 8
multi_troop_class_mounted_crossbowman = 9
multi_troop_class_mounted_musketeer = 10

multi_troop_class_artillery = 11
multi_troop_class_engineer = 12
multi_troop_class_medic = 13
#MOD end


multi_num_valid_entry_points = 64
multi_num_valid_entry_points_div_2 = 32

#normal money management system
multi_battle_round_team_money_add = 500
# multi_destroy_save_or_destroy_target_money_add = 100
# multi_destroy_target_money_add = 1500
# multi_initial_gold_value = 1000
# multi_max_gold_that_can_be_stored = 15000

# multi_killer_agent_standard_money_add = 150 #(2/3 = 100 for battle & destroy, 3/3 = 150 for siege, 4/3 = 200 for deathmatch/team deathmatch/capture the flag/headquarters)
# multi_killer_agent_loot_percentage_share = 12 #(2/3 = 8% for battle & destroy, 3/3 = 12% for siege, 4/3 = 16% for deathmatch/team deathmatch/capture the flag/headquarters)
# multi_dead_agent_loot_percentage_share = 48 #(2/3 = 32% for battle & destroy, 3/3 = 48% for siege, 4/3 = 64% for deathmatch/team deathmatch/capture the flag/headquarters)
# multi_minimum_gold = 1000 #(same in all modes)

# multi_minimum_target_health = 1200

# multi_max_seconds_flag_can_stay_in_ground = 60

# multi_capture_the_flag_score_flag_returning = 1

multi_initial_spawn_point_team_1 = 0
multi_initial_spawn_point_team_2 = 32
# multi_base_point_team_1 = 64
# multi_base_point_team_2 = 65
multi_siege_flag_point = 66
# multi_death_mode_point = 67

multi_headquarters_pole_height = 900
multi_headquarters_flag_height_to_win = 800 #used in sd death mode
multi_headquarters_flag_initial_height = 100 #used in sd death mode
multi_headquarters_max_distance_sq_to_raise_flags = 1600 #4m * 4m * 100 = 1600
multi_headquarters_distance_sq_to_set_flag = 8100 #9m * 9m * 100 = 8100 
multi_headquarters_distance_sq_to_change_flag = 400 #2m * 2m * 100 = 400 
multi_headquarters_distance_to_change_flag = 200 #2m * 100 = 200 
# multi_distance_sq_to_use_belfry = 36 #6m * 6m = 36 (there is no * 100 for this one because it uses get_sq_distance_between_positions_in_meters instead of get_sq_distance_between_positions)
multi_max_sq_dist_between_agents_to_longer_mof_time = 49 #7m * 7m = 49m
min_allowed_flag_height_difference_to_make_score = 50

#these two values are about when master of field will be kicked
# multiplayer_battle_formula_value_a = 15
# multiplayer_battle_formula_value_b = 18000 #think about 18000-20000 if death mod very much happens.

multiplayer_spawn_above_opt_enemy_dist_point = 32 #while finding most suitable spawn point if nearest enemy is further than 32 meters give negative points to that spawn point
multiplayer_spawn_min_enemy_dist_limit = 45 #while finding most suitable spawn point if nearest enemy is closer than 45 meters give negative points to that spawn point, (squared increase)

multiplayer_poll_disable_period = 900 #15 minutes

#menu variables
escape_menu_item_height = 25 #MOD edit #was 40



bignum = 0x40000000000000000000000000000000

op_num_value_bits = 24 + 32

tag_register        =  1
tag_variable        =  2
tag_string          =  3
tag_item            =  4
tag_troop           =  5
tag_faction         =  6
tag_quest           =  7
tag_party_tpl       =  8
tag_party           =  9
tag_scene           = 10
tag_mission_tpl     = 11
tag_menu            = 12
tag_script          = 13
tag_particle_sys    = 14
tag_scene_prop      = 15
tag_sound           = 16
tag_local_variable  = 17
tag_map_icon        = 18
tag_skill           = 19
tag_mesh            = 20
tag_presentation    = 21
tag_quick_string    = 22
tag_track	    			= 23
tag_tableau         = 24
tag_animation       = 25
tags_end            = 26


opmask_register             =  tag_register       << op_num_value_bits
opmask_variable             =  tag_variable       << op_num_value_bits
##opmask_string             =  tag_string         << op_num_value_bits
##opmask_item_index         =  tag_item           << op_num_value_bits
##opmask_troop_index        =  tag_troop          << op_num_value_bits
##opmask_faction_index      =  tag_faction        << op_num_value_bits
opmask_quest_index          =  tag_quest          << op_num_value_bits
##opmask_p_template_index   =  tag_party_tpl      << op_num_value_bits
##opmask_party_index        =  tag_party          << op_num_value_bits
##opmask_scene_index        =  tag_scene          << op_num_value_bits
##opmask_mission_tpl_index  =  tag_mission_tpl    << op_num_value_bits
##opmask_menu_index         =  tag_menu           << op_num_value_bits
##opmask_script             =  tag_script         << op_num_value_bits
##opmask_particle_sys       =  tag_particle_sys   << op_num_value_bits
##opmask_scene_prop         =  tag_scene_prop     << op_num_value_bits
##opmask_sound              =  tag_sound          << op_num_value_bits
##opmask_map_icon           =  tag_map_icon       << op_num_value_bits
opmask_local_variable       =  tag_local_variable << op_num_value_bits
opmask_quick_string         =  tag_quick_string   << op_num_value_bits


def reg(reg_no):
  if (reg_no < 0):
    print ("Error register_no negative")
    cause_error()
  return opmask_register | reg_no

def find_object(objects,object_id):
  result = -1
  num_objects = len(objects)
  i_object = 0
  object_id_lowercase = object_id.lower()
  while (i_object < num_objects) and (result == -1):
    object = objects[i_object]
    if (object[0].lower() == object_id_lowercase):
      result = i_object
    i_object += 1
  return result

#MOD begin
for index in xrange(128):
	globals()['s%d' % index] = index
	globals()['pos%d' % index] = index
	globals()['reg%d' % index] = opmask_register | index
# reg 100+ gives display error

pos_spawn = 3
pos_move = 4
pos_calc = 5
pos_hit = 6
#MOD end

spf_all_teams_are_enemy                      = 0x00000001, 
spf_is_horseman                              = 0x00000002,
spf_examine_all_spawn_points                 = 0x00000004,
spf_team_0_spawn_far_from_entry_32           = 0x00000008,
spf_team_1_spawn_far_from_entry_0            = 0x00000010,
spf_team_1_spawn_far_from_entry_66           = 0x00000020,
spf_team_0_spawn_near_entry_0                = 0x00000040,
spf_team_0_spawn_near_entry_66               = 0x00000080,
spf_team_1_spawn_near_entry_32               = 0x00000100,
spf_team_0_walkers_spawn_at_high_points      = 0x00000200,
spf_team_1_walkers_spawn_at_high_points      = 0x00000400,
spf_try_to_spawn_close_to_at_least_one_enemy = 0x00000800,
spf_care_agent_to_agent_distances_less       = 0x00001000,

#MOD begin
base_archery_wpt = 200

to_player                           = 0
to_all                              = 1

agent_add_carry_weight              = 0
agent_sub_carry_weight              = 1
agent_add_armor_weight              = 2
agent_sub_armor_weight              = 3

walk_by_key                         = 0
walk_by_stamina                     = 1
walk_by_limiter                     = 2


material_earth	               = 0
material_water                 = 1
material_stone                 = 2
material_wood                  = 3
material_metal                 = 4
material_ceramic               = 5
material_glass                 = 6
material_bone                	 = 7
material_leather               = 8
material_fabric                = 9
material_food                	 = 10


prop_move_left                      = 0
prop_move_right                     = 1
prop_move_forward                   = 2
prop_move_backward                  = 3
prop_move_left_forward              = 4
prop_move_right_forward             = 5
prop_move_left_backward             = 6
prop_move_right_backward            = 7
prop_move_left_alt                  = 8
prop_move_right_alt                 = 9
prop_move_forward_alt               = 10
prop_move_backward_alt              = 11
prop_move_left_forward_alt          = 12
prop_move_right_forward_alt         = 13
prop_move_left_backward_alt         = 14
prop_move_right_backward_alt        = 15
prop_action_1                       = 16
prop_action_2                       = 17
prop_action_3                       = 18

scene_type_plain = 1
scene_type_plain_forest = 2
scene_type_steppe = 3
scene_type_steppe_forest = 4
scene_type_desert = 5
scene_type_desert_forest = 6
scene_type_snow = 7
scene_type_snow_forest = 8
scene_type_ocean = 9
scene_type_indoor = 10
scene_type_dungeon = 11

scene_water_ocean = 1
scene_water_ocean_far = 2
scene_water_lake = 3
scene_water_river = 4

missile_arrow = 0
missile_bolt = 1
missile_bullet = 2
missile_thrown = 3
missile_roundshot = 4
missile_bomb = 5
missile_mortar = 6
missile_fire = 7
missile_firepot = 8

volley_free = 0
volley_reload = 1
volley_ready = 2
volley_release = 3

online_status_reset_password = -1
online_status_none = 0
online_status_registered = 1
online_status_incorrect_name = 2
online_status_name_used = 3
online_status_new_player = 4
online_status_banned = 5
online_status_admin = 6

order_menu_main = 0
order_menu_movements = 1
order_menu_formations = 2
order_menu_shot_orders = 3
order_menu_weapons = 4

#server/client
sub_event_max_num_players                   = 2
sub_event_num_bots_in_team                  = 3
# sub_event_friendly_fire                     = 4

# sub_event_melee_friendly_fire               = 5
# sub_event_horse_friendly_fire               = 6
# sub_event_friendly_fire_damage_self_ratio   = 7
# sub_event_friendly_fire_damage_friend_ratio = 8

sub_event_ghost_mode                        = 9
sub_event_control_block_dir                 = 10

# sub_event_add_to_servers_list               = 11
sub_event_respawn_period                    = 12
# sub_event_game_max_minutes                  = 13
sub_event_round_max_seconds                 = 14
sub_event_game_max_points                   = 15
# sub_event_point_gained_from_flags           = 16
# sub_event_point_gained_from_capturing_flag  = 17

sub_event_next_team_faction                 = 18

sub_event_num_bots_voteable                 = 19
sub_event_factions_voteable                 = 20
sub_event_maps_voteable                     = 21
sub_event_player_respawn_as_bot             = 22

sub_event_combat_speed                      = 23

sub_event_respawn_count                     = 24
sub_event_kick_voteable                     = 25
sub_event_ban_voteable                      = 26
# sub_event_valid_vote_ratio                  = 27
sub_event_auto_team_balance_limit           = 28
# sub_event_initial_gold_multiplier           = 29
# sub_event_battle_earnings_multiplier        = 30
# sub_event_round_earnings_multiplier         = 31

# sub_event_show_crosshair                    = 32

sub_event_allow_player_banners              = 33
# sub_event_force_default_armor               = 34
# sub_event_anti_cheat                        = 35

# sub_event_disallow_ranged_weapons           = 36
# sub_event_disallow_melee_weapons            = 37
# sub_event_disallow_armors                   = 38
# sub_event_disallow_horses                   = 39

sub_event_quick_artillery                   = 37
sub_event_server_announcements							= 38
sub_event_all_items													= 39
sub_event_allow_online_chars								= 40
sub_event_allow_faction_troops							= 41

sub_event_cloud_amount                      = 42
sub_event_precipitation_strength            = 43
sub_event_fog_distance                    	= 44
sub_event_thunderstorm                 			= 45
sub_event_wind_strength											= 46
sub_event_wind_direction										= 47
sub_event_day_time                        	= 48

#client only
sub_event_game_type                         = 73
sub_event_renaming_server_allowed           = 89
sub_event_changing_game_type_allowed        = 90
sub_event_max_num_bots                      = 98

pos_x = 0
pos_y = 1
pos_z = 2
#MOD end

#object types for "try_for_prop_instances" operation
somt_object = 1
somt_entry = 2
somt_item = 3
somt_baggage = 4
somt_flora = 5
somt_passage = 6
somt_spawned_item = 7
somt_spawned_single_ammo_item = 8
somt_spawned_unsheathed_item = 9
somt_shield = 10
somt_temporary_object = 11

#WSE begin
#Tooltip types
tooltip_agent = 1
tooltip_horse = 2
tooltip_my_horse = 3
tooltip_container = 5
tooltip_door = 6
tooltip_item = 7
tooltip_leave_area = 8
tooltip_prop = 9
tooltip_destructible_prop = 10

#Human bones
hb_abdomen = 0
hb_thigh_l = 1
hb_calf_l = 2
hb_foot_l = 3
hb_thigh_r = 4
hb_calf_r = 5
hb_foot_r = 6
hb_spine = 7
hb_thorax = 8
hb_head = 9
hb_shoulder_l = 10
hb_upperarm_l = 11
hb_forearm_l = 12
hb_hand_l = 13
hb_item_l = 14
hb_shoulder_r = 15
hb_upperarm_r = 16
hb_forearm_r = 17
hb_hand_r = 18
hb_item_r = 19

#Horse bones
hrsb_pelvis = 0
hrsb_spine_1 = 1
hrsb_spine_2 = 2
hrsb_spine_3 = 3
hrsb_neck_1 = 4
hrsb_neck_2 = 5
hrsb_neck_3 = 6
hrsb_head = 7
hrsb_l_clavicle = 8
hrsb_l_upper_arm = 9
hrsb_l_forearm = 10
hrsb_l_hand = 11
hrsb_l_front_hoof = 12
hrsb_r_clavicle = 13
hrsb_r_upper_arm = 14
hrsb_r_forearm = 15
hrsb_r_hand = 16
hrsb_r_front_hoof = 17
hrsb_l_thigh = 18
hrsb_l_calf = 19
hrsb_l_foot = 20
hrsb_l_back_hoof = 21
hrsb_r_thigh = 22
hrsb_r_calf = 23
hrsb_r_foot = 24
hrsb_r_back_hoof = 25
hrsb_tail_1 = 26
hrsb_tail_2 = 27

#Attack directions
atk_thrust = 0
atk_right_swing = 1
atk_left_swing = 2
atk_overhead = 3

#Game windows
window_inventory = 7
window_party = 8
window_character = 11